var previous;
var readyImages = [];
var loadedCounter = [];
var autoRefresh = 0;
var autoRefreshIntervalId;
var lastRefreshElements = 0;
var enginesLoad = 0;
var searchEnginesCount = 0;
var searchEnginesTotal = 0;
var finish = 0;

function run(searchEngineList, searchTerms){
	
	//var elementList = [];
	var elementList;
	var searchCounter = 0;
	searchEnginesTotal = searchEngineList.length;
	
	margin = 80;
			//ancho = screen.width * 0.95;
			//alto = screen.height*0.75 - margin;
	alto = $(window).height()*0.98 - margin;
	ancho = $(window).width() * 0.98;
	var maximoAlto = alto / 2.2;
	var maximoAncho = ancho / 2.7;
	var minimoAlto = 20;
	var minimoAncho = 20;
	
	
	$.each(searchEngineList, function(index, value) {
		loadedCounter[index] = 0;
		urlGet = "/resultados/" + value + "/" + searchTerms
		previous = [];
		$.getJSON(
			urlGet,
			function(data){
				
				elementList = [];
				
				$.each(data, function(i,item){
					image_instance = new PWImage(item.name, item.thumbnail, maximoAncho, minimoAncho, maximoAlto, minimoAlto, item.rating, item.url);
					elementList.push(image_instance);
				});
				
				if( data.length > 0 )
					loadImages(elementList, index);
				else {
					//console.log( value + ": " + data.length + " results");
					searchEnginesCount++;
				}
			}
			
			
		);
		
		$.ajaxSetup({
			error:function(x,e){
				//~ console.log("Error cargando un servidor");
				searchEnginesCount++;
			}
		});
	});
}


function refreshPhotoWall(iList){
	iList.sort(sortByImageHeight);
	new PhotoWall({
			inject: function() {
				elem = document.getElementById("photowall");
				if (elem != null)
				{
					document.body.removeChild(elem);
				}
				document.body.appendChild(this);
			},
			width: ancho,
			height: alto,
			topMargin: margin,
		},
		iList
	);
	//console.log("End of refresh");
}


function goNext() {
	
	//~ if( finish == 0){
		//~ alert("Loading results. Please wait", "Visuse");
	//~ } else {
	
		usedList = jQuery.grep(readyImages, function(value, index){
			return (value.used != 0);
		});
		//console.log("Next putting out " + usedList.length + "/" + readyImages.length + " elements");
		
		noUsedList = jQuery.grep(readyImages, function(value, index){
			return (value.used == 0);
		});
		
		if( noUsedList.length == 0){
			alert("No more results", "Visuse");
		} else {
			previous.push(usedList);
			readyImages = noUsedList;
			refreshPhotoWall(readyImages);
		}
	//~ }
}

function goBack() {
	
	//~ if( finish == 0){
		//~ alert("Loading results. Please wait", "Visuse");
	//~ } else {
		if (previous.length < 1){
				alert("You can't go back");
		} else {
			previousPage = previous.pop();
			
			readyImages = $.merge(readyImages, previousPage);
			
			$.each(readyImages, function(index, value) { 
				value.used = 0;
			});
			
			refreshPhotoWall(readyImages);
		}
	//~ }
}

function settings() {
	//$.modal("<div><h1>SimpleModal</h1></div>", {options});
	//$("#sample").modal({});
	//~ $("#sample").modal({
		//~ opacity: 80,
		//~ overlayClose: true,
		//~ persist: true
	//~ });
}

// PARA FORMULARIOS
//~ $.modal('<iframe src="' + src + '" height="450" width="830" style="border:0">', {
	//~ closeHTML:"",
	//~ containerCss:{
		//~ backgroundColor:"#fff",
		//~ borderColor:"#fff",
		//~ height:450,
		//~ padding:0,
		//~ width:830
	//~ },
	//~ overlayClose:true
//~ });



function sortByImageHeight(a, b) {
	return b.maxW - a.maxW;
}

var createElement = (function(){
	
	return function(type, attrs) {
		
		var el = document.createElement(type),
			attr, css, event, events;
		
		if (attrs) {
			
			css = attrs.css;
			
			if (css) {
				for (var prop in css) {
					if (!css.hasOwnProperty || css.hasOwnProperty(prop)) {
						try{
							el.style[prop] = typeof css[prop] === 'string' ? css[prop] : css[prop] + 'px';
						} catch(e) { /* Invalid props */ }
					}
				}
			}
			
		}
		
		for (attr in attrs) {
			if (!attrs.hasOwnProperty || attrs.hasOwnProperty(attr)) {
				if (attr !== 'css') {
					el[attr] = attrs[attr];
				}
			}
		}
		
		return el;
	};
	
})();





var loadedFn = function(imgs, i, seID) {
	return function() {
		//console.log( "Loaded " + imgs[i].url );

		imgs[i].lWidth = this.width || this.naturalWidth;
		imgs[i].lHeight = this.height || this.naturalHeight;
		readyImages.push(imgs[i]);
		loadedCounter[seID]++;
		
		//console.log( "Loaded " + loadedCounter[seID] + "/" + imgs.length + "\t\tFile:" + imgs[i].url );
		this.parentNode.removeChild(this);

		if (loadedCounter[seID] === imgs.length) {
			searchEnginesCount++;
			//~ console.log( "Loaded " + searchEnginesCount + "/" + searchEnginesTotal + " search engines " + searchEngineList[seID]);
			if( searchEnginesCount ==  searchEnginesTotal){
				clearInterval(autoRefreshIntervalId);
				refreshPhotoWall(readyImages);
				finish = 1;
				//console.log( "Finish" );
			}
		}
		try {
			delete this.onload;
		} catch(e) {
			this.onload = null;
		}
	};
};

function autoRefreshFunction( ){
	elements = readyImages.length;
	//console.log("AutoRefresh con " + elements);
	if( lastRefreshElements != elements){
		lastRefreshElements = readyImages.length
		refreshPhotoWall(readyImages);
		$.each(readyImages, function(index, value) { 
			value.used = 0;
		});
		
	}
} 

function loadImages(imgs, seID) {
	
	// Activate auto-refresh
	if( autoRefresh == 0){
		autoRefresh = 1;
		autoRefreshIntervalId = setInterval(autoRefreshFunction, 2000); // Cada 2 seg
	}
	
	for (var i = 0; i < imgs.length; ++i) {
		
		img = createElement('img', {
			src: imgs[i].url,
			css: { position: 'absolute', top: -9999, left: -9999 },
			alt: imgs[i].name
		});
		
		document.body.insertBefore(img, document.body.firstChild);
		
		// Wait for img to load, before determining dimensions
		if ( img.complete ) {
			loadedFn(imgs, i, seID).call(img);
		} else {
			img.onerror = loadedFn(imgs, i, seID);
			img.onload = loadedFn(imgs, i, seID);
		}
		
	}
}

function PWImage(name, url, maxW, minW, maxH, minH, rating, link) {
	//console.log( "Name:" + name);
	this.name = name;
	this.url = url;
	this.maxW = rating * maxW;
	this.maxH = rating * maxH;
	this.minW = Math.max(minW, this.maxW*0.2);
	this.minH = Math.max(minH, this.maxH*0.2);
	this.used = 0;
	this.rating = rating;
	this.link = link;
}


